Attribute VB_Name = "Declares"
Private Const SRCCOPY = &HCC0020
'Following 3 lines were added thanks to Rudy Alex Kohn
'Only needed on some computers though
Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long

Public Function CreateSurfaceFromFile(DirectDraw As DirectDraw7, ByVal Filename As String, SurfaceDesc As DDSURFACEDESC2) As DirectDrawSurface7
    On Error GoTo Errinit
    Dim Picture As StdPicture
    Dim Width As Long
    Dim Height As Long
    Dim Surface As DirectDrawSurface7
    Dim hdcPicture As Long
    Dim hdcSurface As Long
    'If filetype = "GIF" Then
    Set Picture = LoadPicture(Filename)
    
    Width = CLng((Picture.Width * 0.001) * 567 / Screen.TwipsPerPixelX)
    Height = CLng((Picture.Height * 0.001) * 567 / Screen.TwipsPerPixelY)
    With SurfaceDesc
        If .lFlags = 0 Then .lFlags = DDSD_CAPS
        .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
        If .ddsCaps.lCaps = 0 Then .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
        If .lWidth = 0 Then .lWidth = Width
        If .lHeight = 0 Then .lHeight = Height
    End With
    Set Surface = DirectDraw.CreateSurface(SurfaceDesc)
    hdcPicture = CreateCompatibleDC(0)
    SelectObject hdcPicture, Picture.Handle
        hdcSurface = Surface.GetDC
    StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, hdcPicture, 0, 0, Width, Height, SRCCOPY
    Surface.ReleaseDC hdcSurface
    
    'GetGifInfo (Filename)
    'If GifInfo.Transparent = True Then
    Dim ddtrans1 As DDCOLORKEY
        If colourdisplay = 16 Then
    coltran = DDColor(RGB(255, 0, 255))
    Else
    coltran = RGB(255, 0, 255)
    End If
    ddtrans1.low = coltran
    ddtrans1.high = coltran
    Surface.SetColorKey DDCKEY_SRCBLT, ddtrans1
    
    'ElseIf filetype = "PNG" Then
    'LoadPNG Filename, Img
    'Width = Img.ImageWidth
    'Height = Img.ImageHeight
    'With SurfaceDesc
    '    If .lFlags = 0 Then .lFlags = DDSD_CAPS
    '    .lFlags = .lFlags Or DDSD_WIDTH Or DDSD_HEIGHT
    '    If .ddsCaps.lCaps = 0 Then .ddsCaps.lCaps = DDSCAPS_OFFSCREENPLAIN
    '    If .lWidth = 0 Then .lWidth = Width
    '    If .lHeight = 0 Then .lHeight = Height
    'End With
    'Set Surface = DirectDraw.CreateSurface(SurfaceDesc)
    'hdcPicture = CreateCompatibleDC(0)
    'SelectObject hdcPicture, Img.Handle
    'hdcSurface = Surface.GetDC
    'StretchBlt hdcSurface, 0, 0, SurfaceDesc.lWidth, SurfaceDesc.lHeight, hdcPicture, 0, 0, Width, Height, SRCCOPY
    'Surface.ReleaseDC hdcSurface
    'ElseIf filetype = "" Then Exit Function
    'End If
    
        DeleteDC hdcPicture
    Set Picture = Nothing
    Set CreateSurfaceFromFile = Surface
    Set Surface = Nothing
Exit Function
Errinit:
'HandleError CurrentModule, "CreateSurfaceFromFile", Err.Number, Err.Description
End Function
Public Sub Getwindowcolours()
On Error GoTo Errinit
Dim DisplayBits
Dim RetVal
hdccaps = GetDC(hdesktopwnd)
DisplayBits = GetDeviceCaps(hdccaps, 12)
RetVal = ReleaseDC(hdesktopwnd, hdccaps)
colourdisplay = DisplayBits
If colourdisplay = 24 Then Let colourdisplay = 32
If colourdisplay <> 16 And colourdisplay <> 32 Then MsgBox "You must have 16/24 or 32 bit colour to run this program"
If frmOptions.Check3.Value = 1 Then Print #filelognumber, "Colour bit: " & colourdisplay
Exit Sub
Errinit:
HandleError CurrentModule, "GetWindowColours", err.Number, err.Description
End Sub
Public Function DDRGB(red As Long, green As Long, blue As Long) As Long
On Error GoTo Errinit
DDRGB = (red \ RedShiftRight) * RedShiftLeft + (green \ GreenShiftRight) * GreenShiftLeft + (blue \ BlueShiftRight) * BlueShiftLeft
Exit Sub
Errinit:
HandleError CurrentModule, "DDRGB", err.Number, err.Description
End Function

Public Sub GetRGBfromColor(ByVal Color As Long, ByRef red As Long, ByRef green As Long, ByRef blue As Long)
On Error GoTo Errinit
Dim HexadecimalValue As String
    HexadecimalValue = Hex(Val(Color))
    
    If Len(HexadecimalValue) < 6 Then
        HexadecimalValue = String(6 - Len(HexadecimalValue), "0") + HexadecimalValue
    End If
    blue = CLng("&H" + Mid(HexadecimalValue, 1, 2))
    green = CLng("&H" + Mid(HexadecimalValue, 3, 2))
    red = CLng("&H" + Mid(HexadecimalValue, 5, 2))
Exit Sub
Errinit:
HandleError CurrentModule, "GetRGBFromColor", err.Number, err.Description
End Sub


Public Function DDColor(RGBColor As Long) As Long
    On Error GoTo Errinit
    Dim RedVal As Long
    Dim GreenVal As Long
    Dim BlueVal As Long
    GetRGBfromColor RGBColor, RedVal, GreenVal, BlueVal
    DDColor = DDRGB(RedVal, GreenVal, BlueVal)
Exit Sub
Errinit:
HandleError CurrentModule, "DDColor", err.Number, err.Description
    End Function

Public Function Loaddirectxsurface(DirectDrawSurface As DirectDrawSurface7, ByVal Filename As String, Optional Width As Long, Optional Height As Long) As DirectDrawSurface7
'On Error GoTo Errinit
Dim ddsd1 As DDSURFACEDESC2
'Checkfiletype (Filename)
'If filetype = "GIF" Then
'    ElseIf filetype = "PNG" Then
'    LoadPNG Filename, Img
'    GameForm.OpenPict.Width = Img.ImageWidth + (GameForm.OpenPict.Width - GameForm.OpenPict.ScaleWidth)
'    GameForm.OpenPict.Height = Img.ImageHeight + (GameForm.OpenPict.Height - GameForm.OpenPict.ScaleHeight)
'    DrawImage GameForm.OpenPict.hdc, Img
'    ElseIf filetype = "" Then Exit Function
'    End If
If Width <> 0 Then
    Tempfile = Filename
    ddsd1.lFlags = DDSD_CAPS
    ddsd1.lHeight = Height
    ddsd1.lWidth = Width
    Set DirectDrawSurface = CreateSurfaceFromFile(DD, Tempfile, ddsd1)
    Else
    Tempfile = Filename
'    GameForm.OpenPict.Picture = LoadPicture(Tempfile)
    ddsd1.lFlags = DDSD_CAPS
    Set DirectDrawSurface = CreateSurfaceFromFile(DD, Tempfile, ddsd1)
End If
    DoEvents
Exit Function
Errinit:
'HandleError CurrentModule, "Loaddirectxsurface", Err.Number, Err.Description
End Function
